library(plyr)
library(dplyr)
library(MPDiR)
library(quickpsy)
library(fitdistrplus)
library(ggplot2)


######
## Have commented out the calculation of thresholds, as everytime we need to add by hand missing values <3 reversals
## For now I have committed the thresholds with these values added (mean 100, var 0)
#####

# remove(list = ls())
# defaultpath <- D:/r-scripts/"
# 
# exppath <- "exp-data/"
# # exppath <- "exp-data_random/"
# 
# setwd(defaultpath)
# source("plotStairCases.R")
# 
# setwd(exppath)
# 
# file_list <- list.files()
# show(file_list)
# 
# setwd(defaultpath)
# 
# if (exists ("allThresholds")) { rm(allThresholds) }
# 
# problemParticipant <- c()
# problemCondition <- c()
# problemDescription <- c()
# 
# # basic loop that reads over participant staircases
# # and computes thresholds per participant, vis, elements
# for (file in file_list){
# 
#   print(file)
# 
#   setwd(exppath)
# 
#   dataFile <- read.csv(file)
# 
# 
#   setwd(defaultpath)
# 
#   # calculate reversals: keep reversal trials (reversal == 1), keep after the 2nd reversal (count > 2), keep non training trials (trial > 0)
#   tmp <- dataFile
#   tmp <- dataFile [ which (dataFile$reversal == 1 & dataFile$count > 2 & dataFile$trial > 0),] # keep after the 2nd reversal
# 
#   statstable <- tmp
#   statstable <- ddply(tmp,
#                       c("participant","chart", "elements"),
#                       summarise,
#                       threshold=mean(time),
#                       threshold_var = var(time)
#   )
# 
#   # this is a bit dirty, but fast...
#   charts <- c('donut','bar','radial')
#   sizes <- c(7,12,24)
# 
# 
#   for(c in charts)
#   {
#     for(s in sizes)
#     {
#       dfSize7 <- subset(dataFile,elements == s & chart == c)#dataFile[which(dataFile$elements == s & as.character(dataFile$dataFile$chart)==as.character(c)),]
# 
#       #we don't have 3 reversals
#       if(nrow(dfSize7[ which (dfSize7$reversal == 1 & dfSize7$count == 3 & dfSize7$trial > 0),]) == 0){
#         problemParticipant <- c(problemParticipant,file)
#         problemCondition <- c(problemCondition,paste(c,".",s))
#         problemDescription <- c(problemDescription,"<3 reversals")
#       }
#       else
#       {
#         maxReversal <- max(dfSize7$count,na.rm=TRUE)
#         maxTrial <- max(dfSize7$trial,na.rm=TRUE)
# 
#         if(maxReversal < 15 & maxTrial <150)
#         {
#           problemParticipant <- c(problemParticipant,file)
#           problemCondition <- c(problemCondition,paste(c,".",s))
#           problemDescription <- c(problemDescription,"early termination")
#         }
#       }
#     }
#   }
# 
# 
#   mydata <- dataFile[which (dataFile$trial > 0),] # no training
#   mydata <- mydata[order(mydata$participant, mydata$chart, mydata$elements),] # order before join
#   statstable <- statstable[order(statstable$participant, statstable$chart, statstable$elements),] # order before join
#   mydatawithstats <- join (mydata,statstable) # join by = c("participant","chart","elemenents")) to add the threshold for plotting purposes
# 
#   start_stair <- subset(dataFile,count==3)
#   start_stair$start <- start_stair$trial
#   mydatawithstats <- join (mydatawithstats,start_stair)
# 
#   tmp_table <- ddply(mydatawithstats,
#                      c("chart", "elements"),
#                      summarise,
#                      start = max(mydatawithstats$start,na.rm = TRUE)
#   )
# 
# 
# 
#   if ( !exists("allThresholds") ){
#     allThresholds <- statstable
#   } else {
#     allThresholds <- rbind(allThresholds,statstable)
#   }
# 
# }
# 
# setwd(defaultpath)
# 
# # problem cases
# write.csv(data.frame(problemParticipant,problemCondition,problemDescription), file="problems.csv")
# #write.csv(data.frame(problemParticipant,problemCondition,problemDescription), file="problems_random.csv")
# 
# # threshold statistics per participant (mean, variance)
# write.csv(allThresholds, file="threshold_statistics.csv")
# #write.csv(allThresholds, file="threshold_statistics_random.csv")
# 


#######
#  deal with any missing values by hand <3 reversals
##

allThresholds <- read.table("threshold_statistics.csv", header=T, sep=",")
#allThresholds <- read.table("threshold_statistics_random.csv", header=T, sep=",")

threshold_aggregated_stats <- ddply(allThresholds,
                      c("chart", "elements"),
                      summarise,
                      threshold_mean = mean(threshold),
                      threshold_var = mean(threshold_var),
                      threshold_sd = sqrt(mean(threshold_var))
)

# threshold statistics aggregated for all participants (mean, variance)
write.csv(threshold_aggregated_stats, file="threshold_aggregated_statistics.csv")
#write.csv(threshold_aggregated_stats, file="threshold_aggregated_statistics_random.csv")

# check for correlation between error rate and sd
errors <- read.table("error_table.csv", header=T, sep=",")

errors <- errors [order(errors$chart, errors$elements),]

errors_and_thresholds <- join(threshold_aggregated_stats,errors)

ggplot(errors_and_thresholds, aes(x=mean_err, y=threshold_sd, color=chart, size=elements)) +
geom_point() 
ggsave("error_threshold_plot.pdf", width=8, height= 2)


cor.test(errors_and_thresholds$threshold_sd, errors_and_thresholds$mean_err, method="pearson")
cor.test(errors_and_thresholds$threshold_sd, errors_and_thresholds$mean_err, method="spearman")
cor.test(errors_and_thresholds$threshold_sd, errors_and_thresholds$mean_err, method="kendall")

