  
  library(devtools)
  library(easyGgplot2)
  
  
  plotStaircases <- function (mydata){
  
    show(unique(mydata$participant))
    show(unique(mydata$chart))
    show(unique(mydata$elements))
  
   p <-  ggplot(mydata,aes(x=trial, y=time, group=1))+
         geom_line()+
         geom_point( aes(colour = factor(answer)), show.legend=FALSE)+
         scale_color_manual(values = c("correct" = "black", "error" = "orangered1")) +
         geom_hline( aes(yintercept = threshold), data=mydata, colour = "steelblue4", linetype="dashed")+
         geom_vline( aes(xintercept = start), data=mydata, colour = "steelblue4", linetype="dashed")+
            theme_light()+  
     
         ggtitle (unique(mydata$participant)) +
          xlim(0, 150) + ylim(0,9000) + # change limits if points our outside
          facet_grid(chart~elements)
     
    ggsave( paste("plots_random/staircase_", unique(mydata$participant), ".pdf", sep=""), 
            plot = p,
            device=NULL, 
            width=15, height=10
            )
    
    # ggsave( paste("plots_random/staircase_", unique(mydata$participant), ".svg", sep=""), 
    #         plot = p,
    #         device=NULL, 
    #         width=15, height=10
    # )
    
    return(1)
  }
  
  
  
  
  plotLogStaircases <- function (mydata){
    
    show(unique(mydata$participant))
    show(unique(mydata$chart))
    show(unique(mydata$elements))
    
    p <-  ggplot(mydata,aes(x=trial, y=time, group=1))+
      geom_line()+
      geom_point( aes(colour = factor(answer)), show.legend=FALSE)+
      scale_color_manual(values = c("correct" = "black", "error" = "orangered1")) +
      geom_hline( aes(yintercept = threshold), data=mydata, colour = "steelblue4", linetype="dashed")+
      geom_vline( aes(xintercept = start), data=mydata, colour = "steelblue4", linetype="dashed")+
      theme_light()+  
      ggtitle (unique(mydata$participant)) +
      xlim(0, 150) + ylim(0,9000) +
      scale_y_log10() + 
      facet_grid(chart~elements)
    
    ggsave( paste("plots_random/log_staircase_", unique(mydata$participant), ".pdf", sep=""), 
            plot = p,
            device=NULL, 
            #          width=11, height=8.5
            width=15, height=10
    )
    
    return(1)
  }
  
